<mat-tab-group>
  <mat-tab label="Create New">
    <div fxLayout="row wrap">
      <div fxFlex.gt-sm="50" fxFlex.xs="100" fxFlex="50">
        <form [formGroup]="newForm">
          <mat-card>
            <mat-card-content>
              <h5>Form Settings</h5>
              <mat-form-field class="example-full-width">
                <input autocomplete="off" matInput placeholder="Title" type="text" formControlName="title" />
              </mat-form-field>
              <mat-form-field class="example-full-width">
                <input autocomplete="off" matInput placeholder="Abbreviation" type="text"
                  formControlName="abbreviation" />
              </mat-form-field>
              <mat-form-field class="example-full-width">
                <mat-select matInput placeholder="Owner" formControlName="claims">
                  <mat-option value="">Anyone</mat-option>
                  <mat-option value="Admin">Admin</mat-option>
                </mat-select>
              </mat-form-field>
            </mat-card-content>
          </mat-card>

          <mat-card *ngIf="questionData">
            <mat-card-content>
              <h5>Form Components</h5>

              <div formArrayName="questions">
                <mat-vertical-stepper>
                  <mat-step *ngFor="let question of questionData(newForm); let i = index" [formGroupName]="i"
                    [label]="'Question ' + (i+1)">
                    <mat-form-field class="example-full-width">
                      <input autocomplete="off" matInput placeholder="Question" type="text" formControlName="label" />
                    </mat-form-field>
                    <mat-form-field class="example-half-width">
                      <mat-select matInput placeholder="Question Type" formControlName="type">
                        <mat-option value="input">Text</mat-option>
                        <mat-option value="date">Date and/or Time</mat-option>
                        <mat-option value="checkbox">Checkbox</mat-option>
                        <mat-option value="radiobutton">Radio Button List</mat-option>
                        <mat-option value="select">Dropdown List</mat-option>
                      </mat-select>
                    </mat-form-field>
                    <mat-form-field class="example-half-width">
                      <mat-select matInput placeholder="Input Type" formControlName="inputType">
                        <mat-option value="text">Text</mat-option>
                        <mat-option value="email">Email</mat-option>
                        <mat-option value="password">Password</mat-option>
                        <mat-option value="number">Number</mat-option>
                      </mat-select>
                    </mat-form-field>
                    <mat-form-field class="example-full-width">
                      <input autocomplete="off" matInput placeholder="Question Name" type="text"
                        formControlName="name" />
                    </mat-form-field>
                    <hr />
                    <div formArrayName="validators">
                      <mat-card class="box-blue">
                        <mat-card-content>
                          <div *ngFor="
                              let validator of questionValidationData(question);
                              let k = index
                            " [formGroupName]="k">
                            <mat-form-field class="example-half-width">
                              <mat-select matInput placeholder="Type" formControlName="name">
                                <mat-option value="required">Required</mat-option>
                                <mat-option value="pattern">Pattern</mat-option>
                              </mat-select>
                            </mat-form-field>
                            <mat-form-field class="example-half-width">
                              <mat-select matInput placeholder="Pattern" formControlName="validatorpattern">
                                <mat-option value="^[a-zA-Z]+$">Text Only</mat-option>
                                <mat-option value="^[a-z0-9._%+-]+@[a-z0-9.-]+.[a-z]{2,4}$">Email</mat-option>
                              </mat-select>
                            </mat-form-field>
                            <mat-form-field class="example-three-quarter-width">
                              <input autocomplete="off" matInput placeholder="Message" type="text"
                                formControlName="message" />
                            </mat-form-field>
                            <button type="button" mat-mini-fab class="btn-danger"
                              (click)="removeQuestionValidator(k, i)">
                              <mat-icon>clear</mat-icon>
                            </button>
                          </div>
                          <button type="button" mat-raised-button (click)="addQuestionValidator(i)" style="float:right">
                            Add Validation
                          </button>
                        </mat-card-content>
                      </mat-card>

                    </div>

                    <hr />
                    <div formArrayName="options">

                      <mat-card class="box-blue">
                        <mat-card-content>
                          <div *ngFor="
                          let option of questionOptionsData(question);
                          let j = index
                        " [formGroupName]="j">
                            <mat-form-field class="example-half-width">
                              <input autocomplete="off" matInput placeholder="Option" type="text"
                                formControlName="option" />
                            </mat-form-field>
                            <mat-form-field class="example-third-width">
                              <input autocomplete="off" matInput placeholder="Order Number" type="number"
                                formControlName="ordernumber" />
                            </mat-form-field>
                            <button type="button" mat-mini-fab class="btn-danger" (click)="removeQuestionOption(j, i)">
                              <mat-icon>clear</mat-icon>
                            </button>
                          </div>
                          <button type="button" mat-raised-button (click)="addQuestionOption(i)" style="float:right">
                            Add List Option
                          </button>
                        </mat-card-content>
                      </mat-card>

                    </div>
                    <hr />
                    <div formArrayName="rules">

                      <mat-card class="box-blue">
                        <mat-card-content>
                          <div *ngFor="
                          let rule of questionRulesData(question);
                          let l = index
                        " [formGroupName]="l">
                            <mat-form-field class="example-full-width">
                              <mat-select matInput placeholder="Depends on..." formControlName="dependOnQuestionID">
                                <mat-option *ngFor="let question of questionData(newForm)"
                                  [value]="question.value.name">{{question.value.name}}</mat-option>
                              </mat-select>
                            </mat-form-field>
                            <div formArrayName="trigger">
                              <div *ngFor="let trig of questionTriggerData(rule)" [formGroupName]="0">
                                Trigger:
                                <mat-form-field class="example-third-width">
                                  <mat-select matInput placeholder="Type" formControlName="type">
                                    <mat-option value="NULL">Is Blank</mat-option>
                                    <mat-option value="NOT NULL">Is not Blank</mat-option>
                                    <mat-option value="=">Equals</mat-option>
                                    <mat-option value="!=">Does not equal</mat-option>
                                    <mat-option value=">">Greater than</mat-option>
                                    <mat-option value="<">Less than</mat-option>
                                  </mat-select>
                                </mat-form-field>
                                <mat-form-field class="example-third-width">
                                  <input autocomplete="off" matInput placeholder="Value" type="text"
                                    formControlName="value" />
                                </mat-form-field>
                              </div>
                            </div>
                            <mat-form-field class="example-third-width">
                              <mat-select matInput placeholder="Action" formControlName="action">
                                <mat-option value="Visible">Visible</mat-option>
                                <mat-option value="Disable">Disable</mat-option>
                                <mat-option value="Auto">Auto-Fill</mat-option>
                              </mat-select>
                            </mat-form-field>
                            <mat-form-field class="example-half-width">
                              <input autocomplete="off" matInput placeholder="Action Value" type="text"
                                formControlName="actionValue" />
                            </mat-form-field>
                            <button type="button" mat-mini-fab class="btn-danger" (click)="removeQuestionRule(l, i)">
                              <mat-icon>clear</mat-icon>
                            </button>
                          </div>
                          <button type="button" mat-raised-button (click)="addQuestionRule(i)" style="float:right">
                            Add Rule
                          </button>
                        </mat-card-content>
                      </mat-card>

                    </div>
                    <hr />
                    <button type="button" mat-raised-button class="btn-danger" style="width: 100%"
                      (click)="removeQuestion(i)">
                      Remove this Component
                    </button>
                    <hr />
                    <div>
                      <button type="button" *ngIf="i > 0" mat-raised-button matStepperPrevious type="button"
                        style="width:49%" color="primary">Back</button>
                      &nbsp;
                      <button type="button" *ngIf="questionData(newForm).length > 1 && i < questionData(newForm).length"
                        mat-raised-button matStepperNext type="button" style="width:49%" color="accent">Next</button>
                    </div>
                  </mat-step>
                </mat-vertical-stepper>
                <button type="button" mat-raised-button (click)="addQuestion()" style="width: 100%;">
                  Add a Component
                </button>
              </div>

            </mat-card-content>
          </mat-card>

          <mat-card>
            <mat-card-content>
              <button type="button" mat-raised-button color="primary" (click)="previewForm(newForm.value)"
                style="width:100%;">
                Preview Form
              </button>
              <br /><br />
              <button type="button" mat-raised-button class="btn-danger" (click)="resetNewForm()" style="width:100%;">
                Clear
              </button>
            </mat-card-content>
          </mat-card>

        </form>
      </div>

      <div fxFlex.gt-sm="50" fxFlex.xs="100" fxFlex="50">
        <mat-card>
          <mat-card-content>
            <h5>Preview Form</h5>
            <div *ngIf="!preview">Please complete form options</div>

            <div *ngIf="preview && preview.questions">
              <dynamic-form [fields]="preview.questions"></dynamic-form>
            </div>
          </mat-card-content>
        </mat-card>

        <mat-card *ngIf="preview">
          <mat-card-content>
            <button type="button" mat-raised-button color="primary" (click)="onSubmit(newForm.value)" style="width:49%">
              Save Form
            </button>
            &nbsp;
            <button type="button" mat-raised-button color="warn" (click)="resetNewForm()" style="width:49%">
              Clear
            </button>
          </mat-card-content>
        </mat-card>
      </div>
    </div>
  </mat-tab>

  <mat-tab *ngFor="let form of formArray" [label]="form.title">
    <app-view-form [selectedForm]="form"></app-view-form>
  </mat-tab>
</mat-tab-group>
